;SNOW.ASM - By b0nu$, 1997
.286
SEG_A     SEGMENT
          ASSUME CS:SEG_A, DS:SEG_A
          ORG     100H

SNOW	  PROC FAR
	  INIT:   JMP     START
	     
rgb		db	3 dup(?)	; Array che contiene i valori di
					;  R G B del colore
num_rnd_val	dw	12345		; A caso
num_rnd_mul	dw	9421		; A caso (diverso da 0 e pari)
					;	 (vedi nota finale)



        START:  
		mov	ax,0013h
		int	10h		;imposto modalit 320x200
		
		xor	ax,ax
		
loop_pal:	mov	rgb[0],al
		mov	rgb[1],al
		mov	rgb[2],al
		CALL 	Set_Pal	  ;imposto la palette con tutte le
				  ;tonalit di grigio nel quale si ha R=G=B.
		inc	al
		jne	loop_pal		
		
		xor	bx,bx		;x=0
Ciclo_x:	xor	dx,dx		;y=0	;parto da 0,0
		
Ciclo_y:	push	dx		;questo ciclo posiziona a caso
					;pixel sullo schermo
		push	dx	
		CALL	Random
		pop	dx
  		CALL Put_Pixel
		pop	dx
		inc	dx
		cmp	dx,0C8h		;200
		jne	Ciclo_y
		inc	bx
		cmp	bx,0140h	;320
		jne	Ciclo_x
		
		mov	ax,0003h
		int	10h		;imposto modalit txt
          RETN
SNOW      ENDP

; stampa un pixel alle coordinate y*256 + x*64
;  (se c' overflow vale l'implementazione circolare)
Put_Pixel	PROC 		;dx=y  bx=x   ah=col
		push	ax	;usa l'accesso diretto in memoria video
		mov  ax,0A000h
   		mov  es,ax
		push	bx
		mov	dh,dl
		xor	dl,dl
		shl	bx,6
		add	dx,bx
		pop	bx
		add	bx,dx
		mov	di,bx
		;xor     al,al
		pop	ax	;prelevo il colore
		mov	es:[di],ah
		RET
Put_Pixel	ENDP

Set_Pal	PROC				;al=colore
		mov    dx,3c8h
   		;mov    al,[col]
	   	out    dx,al
   		inc    dx
   		mov    al,rgb[0]	;red
	 	out    dx,al
   		mov    al,rgb[1]	;green
   		out    dx,al	
  	 	mov    al,rgb[2]	;blue
   		out    dx,al
		RET
Set_Pal	ENDP

Random	PROC			;Genera un numero casuale con l'algoritmo
				; di D.Lehmer 
		mov	ax,num_rnd_val
		mul	num_rnd_mul
		inc	ax
		mov	num_rnd_val,ax
		RET
Random	ENDP

SEG_A     ENDS
          END     INIT
