;TUT9.ASM - by Antonio 1999
;Somma due numeri in BCD.

SEG_A		SEGMENT
		ASSUME CS:SEG_A, DS:SEG_A
		ORG	100H

Somma	PROC FAR
INIT:	JMP	START			;salta a START

; costanti modificabili
N_CIFRE         EQU     8   ; numero di cifre dei numeri
                            ; ricorda: metti zeri in testa

Num1    DB      1,2,3,4,5,6,7,8
Num2    DB      8,7,6,5,4,3,2,1
Ris     DB    0,0,0,0,0,0,0,0,0,'$'     ;terminatore

	START:
	
; -- Somma dei due numeri

        mov     cx,N_CIFRE      ;numero di cifre da sommare
        mov     di,cx           ;punta alla cifra pi a destra di Ris
        mov     si,N_CIFRE-1    ;... di Num1 o Num2
        clc                     ;il riporto  0 all'inizio

SommaCifra:
        mov     al,Num1[si]
        adc     al,Num2[si]     ;somma due cifre col riporto
        aaa                     ;metto a posto le cifre
        mov     Ris[di],al
        dec     di              ;non cambieranno il Carry Flag
        dec     si
        loop    SommaCifra
        mov     Ris[di],0
        jnc     FineSomma
        inc     Ris[di]         ;Ris ora ha nove cifre significative
FineSomma:


; -- asciizza il risultato (ehil, ho inventato un nuovo termine)
;    cio prepara per la stampa

        mov     cx,N_CIFRE+1
        mov     di,0
Ascii:  add     Ris[di],30h	;oppure:    or     Ris[di],30h
        inc     di
        loop    Ascii


; -- stampa risultato

StampaRis:
	mov	ah,09h
        mov     dx,OFFSET Ris
        int     21h

        RETN
Somma	ENDP

SEG_A	ENDS
        END     INIT
