;TUT9BIS.ASM - by Antonio 1999
;Legge due numeri di N_CIFRE cifre e li somma (in BCD).
;NOTA : 4+3 si scrive 04+03 !!! (se N_CIFRE  2)

SEG_A		SEGMENT
		ASSUME CS:SEG_A, DS:SEG_A
		ORG	100H

Somma	PROC FAR
INIT:	JMP	START			;salta a START

; costanti modificabili
N_CIFRE         EQU     8   ; i numeri hanno N_CIFRE cifre
Msg_Num1   	DB 	"Inserisci il primo addendo :  $" 
Msg_Num2   	DB 	13,10,"Inserisci il secondo addendo :  $"
Num1    DB      N_CIFRE   DUP(?)
Num2    DB      N_CIFRE   DUP(?)
Ris     DB      N_CIFRE+1 DUP(?), '$'

	START:

; -- Lettura del primo addendo (ricorda: metti 0 in testa)
            mov   dx,OFFSET Msg_Num1     ;stampo il primo msg       
            mov   ah,09h                  
	    int   21h                    
		
	    mov	  ah,01h
	    mov   si,0
Leggi_1:    int   21h                     ;leggo un carattere
	    cmp	  al,0Dh		  ;Enter ?
	    je	  Fine_1
	    sub	  al,30h
            mov   BYTE PTR Num1[si],al    ;lo metto in Num1
	    inc	  si
	    jmp	  Leggi_1
Fine_1: 	

; -- Lettura del secondo addendo
            mov   dx,OFFSET Msg_Num2      ;stampo il secondo msg
       	    mov   ah,09h                  
	    int   21h   
		
	    mov	  ah,01h
	    mov	  si,0
Leggi_2:    int   21h                     ;leggo  un carattere
	    cmp	  al,0Dh			;Enter ?
	    je	  Fine_2
	    sub	  al,30h
            mov   BYTE PTR Num2[si],al    ;lo metto in Num2
	    inc	  si
	    jmp	  Leggi_2
Fine_2:	


; -- salta una riga
	    mov	  ah,02h
	    mov	  dl,13
	    int	  21h
	    mov	  dl,10
	    int	  21h


; -- Somma dei due numeri

        mov     cx,N_CIFRE      ;numero di cifre da sommare
        mov     di,cx           ;punta alla cifra pi a destra di Ris
        mov     si,N_CIFRE-1    ;... di Num1 o Num2
        clc                     ;il riporto  0 all'inizio

SommaCifra:
        mov     al,Num1[si]
        adc     al,Num2[si]     ;somma due cifre col riporto
        aaa                     ;metto a posto le cifre
        mov     Ris[di],al
        dec     di              ;non cambieranno il Carry Flag
        dec     si
        loop    SommaCifra
        mov     Ris[di],0
        jnc     FineSomma
        inc     Ris[di]         ;Ris ora ha nove cifre significative
FineSomma:


; -- prepara per la stampa

        mov     cx,N_CIFRE+1
        mov     di,0
Ascii:  add     Ris[di],30h	;oppure:    or     Ris[di],30h
        inc     di
        loop    Ascii


; -- stampa risultato

StampaRis:
	mov	ah,09h
        mov     dx,OFFSET Ris
        int     21h

        RETN
Somma	ENDP

SEG_A	ENDS
        END     INIT
